\section{Related Work}
\label{sec:RelWork}
Solutions for Energy and Power Aware Job Scheduling and Resource Management have been approached from several sides, the related work section will look at Academic Research Projects. 
Solutions provided by vendors will not be covered and we kindly refer to the whitepaper for a non exhaustive list.


%Find different headings:
\subsection{Accademic Research}
Several research avenues have been explored in order to curtail the power 
and energy consumption of HPC systems. In the rest of this section we are 
going to present a brief overview of the techniques found in the 
literature and current state-of-the-art.

A detailed survey of the research on power management techniques for high
performance systems can be found in \cite{maiterth2017power, Liu2010, cameron2005high}.
As clearly pointed out by Hsu et al.\cite{HsuFA05}, a change of the
current perspective is required: 
the focus must shift from performance-based metrics (such as the 
performance-power ration) to new ones which  take into account different
aspects of the problem, i.e. integrating the notions of total cost of
ownership, productivity and reliability. 

Several works aim at curbing the overall power consumption at the supercomputer level., i.e. power capping. 
Sarood et al. \cite{Sarood2014} describe an ILP model to enforce power capping in a HPC cluster through over-provisioning. Their approach combines over-provisioning with a power-aware scheduler.  
Mammela et al. \cite{mammela2012energy} present an energy-aware scheduler that turns off idle nodes every time the scheduler detects that no activity can be scheduled for a sufficiently long time on a certain node. 

Many approaches takes advantage by ``moldable jobs'', i.e. jobs which can run with different configurations (number of nodes, cores or threads) \cite{Bailey:2014:ACS:2703009.2706736,Patki:2015:PRM:2749246.2749262,Mualem:2001:UPW:380314.380315}: given the current power consumption and power budget, the best configuration is chosen for each job before its start. Other authors tried to exploit the power and performance variability among nodes and components within the same system \cite{Inadomi:2015:AMI:2807591.2807638,shoukourian2015adviser}.

Dynamic Voltage and Frequency Scaling (DVFS) allows to exchange processor performance for lower power consumption and have been explored as mean to increase the supercomputer's energy-efficiency \cite{8081827, 10.1007/978-3-319-07518-1_25,Freeh:2007:AET:1263127.1263246}. However, reducing the operating clock may increase the duration of the applications which run on the now more energy efficient resources \cite{8081827, 10.1007/978-3-319-07518-1_25, Hsu:2005:PRS:1105760.1105766}. Approaches to overcome this issue take advantage of compute, memory or communication phases \cite{Freeh:2007:AET:1263127.1263246}, heterogeneous nodes \cite{8081827}.
An extension of these approaches into the job scheduling is discussed by Etinski et al. \cite{Etinski2010,Etinski:2012:PJS:2400744.2400966}, which extends the standard job scheduling algorithm with power budgeting capability through DVFS. 

An alternative to the direct control of frequency scaling is Intel's Running Average Power Limit (RAPL) \cite{David:2010:RMP:1840845.1840883}, which provides a software configurable and hardware enforced power cap. Several works have combined Intel's RAPL feature with job scheduling algorithms\cite{Bodas:2014:SPS:2689710.2689713,Ellsworth:2015:DPS:2807591.2807643}. These approaches relies on allocating a reduced power budget to each node and sockets. Ellsworth et al. \cite{Ellsworth:2015:DPS:2807591.2807643} dynamically share the budget between nodes aiming to give more power to the nodes which runs critical job and processes. 

An orthogonal approach to respect a system level power budget and presented consists in do not limit the performance of the processing elements but limiting the jobs concurrently running on the computational resources \cite{BorghesiHPCS15, BorghesiCP15, BorghesiISC16}. 
 
Differently from previous techniques which focuses on enforcing a power cap, some works focuses on minimizing the energy consumption and/or the related energy costs \cite{10.1007/978-3-319-07518-1_25,BHATTACHARYA2013183,KHEMKA201514,Leal2016}. These energy aware schedulers and resource managers act on the job execution order alone, without requiring any hardware modification nor any change in the operational frequencies of the computing nodes. 

A very important aspect for energy and power aware job schedulers and resource managers is the knowledge of the features of an application before its execution; this allows to take informed decisions. Approaches ranges from: application's tag, historical data and model regression \cite{shoukourian2014predicting}; User's meta-information such as a tag identifying similar jobs\cite{10.1007/978-3-319-07518-1_25}; Machine Learning techniques and jobs submission's information \cite{BorghesiISC16,Sirbu:2016:PCM:2990973.2991005}. 

From the above discussion we can see that in the recent years several techniques, algorithms and strategies have been proposed in the state-of-the-art for energy and power aware job schedulers and resource managers in the high performance computing domain. However, from the initial findings of the survey these techniques have not yet been internalized into the supercomputing centers. This gap, underline the importance of the work presented in this paper in highlighting the current practice and trends of the worldwide supercomputing centers with focus on energy and power management.

%Vendor Supported JSRM solutions:
\subsection{Vendor supported JSRM solutions}

In the JSRM space, the schedulers and runtimes are highlighted.

Moab HPC Suite, a workload and resource orchestration platform that automates 
the scheduling, managing, monitoring and reporting of HPC workloads at scale.
Over the past years, Moab has introduced features for power management of HPC resources.
These include management of power states idle nodes as well as CPU clock frequency on
an per application basis, and build on the IMPI power management.~\cite{Moab}

PBS Professional, by Altair, is a workload manager and job scheduler for 
high-performance computing environments.
The current release of the product, PBS Professional 13.0, includes several 
capabilities related to energy and power management. The technology builds on PMI.~\cite{PBS}

SchedMD introduced Power Management support in their open source solution SLURM, and include several aspects of Monitoring and control.~\cite{Slurm}

IBM - Platform LSF Suite of tools support energy aware scheduling and additional node power managemnt features.~\cite{LSF}

Regarding energy and power aware runtimes, GEOPM~\cite{10.1007/978-3-319-58667-0_21}, by Intel, provides a scalable job power management framework. To foster software-hardware co-design energy management solutions that address exascale power challenges and improve performance and energy efficiency. 
The work is build of an extensible plugin-framework that optimizes the jobs resource needs and is designed to scale with the jobs requirements.

This is a non exhaustive list, and 
the group is aware of other \EPAJSRM vendor solutions in development, which are not published or released, yet.
